<template>
  <div>
    <h2 id="page-heading" data-cy="NotificacionHeading">
      <span v-text="$t('gatewayApp.manillaNotificacion.home.title')" id="notificacion-heading">Notificacions</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaNotificacion.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'NotificacionCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-notificacion"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaNotificacion.home.createLabel')"> Create a new Notificacion </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && notificacions && notificacions.length === 0">
      <span v-text="$t('gatewayApp.manillaNotificacion.home.notFound')">No notificacions found</span>
    </div>
    <div class="table-responsive" v-if="notificacions && notificacions.length > 0">
      <table class="table table-striped" aria-describedby="notificacions">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaInicio')">
              <span v-text="$t('gatewayApp.manillaNotificacion.fechaInicio')">Fecha Inicio</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaInicio'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaActualizacion')">
              <span v-text="$t('gatewayApp.manillaNotificacion.fechaActualizacion')">Fecha Actualizacion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaActualizacion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('estado')">
              <span v-text="$t('gatewayApp.manillaNotificacion.estado')">Estado</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'estado'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tipoNotificacion')">
              <span v-text="$t('gatewayApp.manillaNotificacion.tipoNotificacion')">Tipo Notificacion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'tipoNotificacion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('token.tokenConexion')">
              <span v-text="$t('gatewayApp.manillaNotificacion.token')">Token</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'token.tokenConexion'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="notificacion in notificacions" :key="notificacion.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'NotificacionView', params: { notificacionId: notificacion.id } }">{{
                notificacion.id
              }}</router-link>
            </td>
            <td>{{ notificacion.fechaInicio ? $d(Date.parse(notificacion.fechaInicio), 'short') : '' }}</td>
            <td>{{ notificacion.fechaActualizacion ? $d(Date.parse(notificacion.fechaActualizacion), 'short') : '' }}</td>
            <td>{{ notificacion.estado }}</td>
            <td>{{ notificacion.tipoNotificacion }}</td>
            <td>
              <div v-if="notificacion.token">
                <router-link :to="{ name: 'TokenDispView', params: { tokenDispId: notificacion.token.id } }">{{
                  notificacion.token.tokenConexion
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'NotificacionView', params: { notificacionId: notificacion.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'NotificacionEdit', params: { notificacionId: notificacion.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(notificacion)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.manillaNotificacion.delete.question"
          data-cy="notificacionDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-notificacion-heading" v-text="$t('gatewayApp.manillaNotificacion.delete.question', { id: removeId })">
          Are you sure you want to delete this Notificacion?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-notificacion"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeNotificacion()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./notificacion.component.ts"></script>
